#include "stattest.h"
team_id dateam;

int main()
 {
  stapp *app=new stapp(AppSig);
  app->Run(); 
  delete app;
  return 0;
 }

bool stapp::QuitRequested()
 {
  return true;
 }

stapp::stapp(char *appsig):BApplication(appsig)
 {
  Lock();
  BRect r;
  r.top=100;
  r.bottom=200;
  r.left=100;
  r.right=600;
  w=new win(r,"Status Tester",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_NOT_ZOOMABLE,B_CURRENT_WORKSPACE);
  a=new RDW_Forward(Team(),w);
  dateam=0;
  teamset=false;
  Unlock();
  BMessage *msg=new BMessage(RDW_WhereAreYou);
  be_roster->Broadcast(msg);
  delete msg;
 } 

bool win::QuitRequested()
 {
  return true;
 }

win::win(BRect frame, const char *title, window_type type, uint32 flags, uint32 wspaces):BWindow(frame,title,type,flags,wspaces)
 {
  Lock();
  msgs[0]=new BMessage(textc);
  msgs[1]=new BMessage(buttp);
  mv=new BView(Bounds(),"view",B_FOLLOW_ALL,B_WILL_DRAW|B_FRAME_EVENTS|B_FULL_UPDATE_ON_RESIZE);
  BRect r(Bounds());
  r.bottom=50;
  tc=new BTextControl(r,"tc","text:","this is just a test",msgs[0],B_FOLLOW_ALL,B_WILL_DRAW|B_NAVIGABLE|B_FRAME_EVENTS);
  tc->SetModificationMessage(msgs[0]);
  cnt=0;
  tc->SetDivider(40);
  strcpy(text,tc->Text());
  mv->AddChild(tc);
  r=Bounds();
  r.top=55;
  r.left=r.right/2;
  butt=new BButton(r,"butt","send",msgs[1],B_FOLLOW_ALL,B_NAVIGABLE|B_WILL_DRAW|B_FRAME_EVENTS);
  r=Bounds();
  r.top=55;
  r.right/=2;
  r.right-=5;
  count=new BStringView(r,"usethreadcount","none",B_FOLLOW_ALL,B_WILL_DRAW);
  mv->AddChild(count);
  mv->AddChild(butt);
  AddChild(mv);
  Unlock();
  Show();
 }

win::~win()
 {
  be_app->PostMessage(B_QUIT_REQUESTED);
 }

void stapp::MessageReceived(BMessage *msg)
 {
  switch(msg->what)
   {
    default:
     {
      BMessage *copy1=new BMessage(msg),*copy2=new BMessage(msg);
      a->MessageReceived(msg);
      BMessenger *msgr=new BMessenger(NULL,dateam,NULL);
      msgr->SendMessage(copy1);
      delete msgr;
      BApplication::MessageReceived(copy2);    
     };break;
   }
 }
/*
Note that in this app, I've decided to use a BMessenger to send messages to
the RDW_Forward object. You might find it easier to do it another way.
I don't program for a living after all...
*/

void win::MessageReceived(BMessage *msg)
 {
  Lock();
  switch(msg->what)
   {
    case textc:
     {
      strcpy(text,tc->Text());
     };break;
/*
    case RDW_StatusWindowRunning:
     {
      cnt++;
      char temp[100];
      sprintf(temp,"use thread %d",cnt);
      count->SetText(temp);
     };break;
    case RDW_UseThread:
     {
      cnt++;
      char temp[100];
      sprintf(temp,"use thread %d",cnt);
      count->SetText(temp);
     };break;
//These two handlers were used to update a counter in the lower left corner
//of the stattest's window, where the word "none" resides.
*/
    case buttp:
     {
       BMessage *package=new BMessage(RDW_DisplayString);
       package->AddInt32("length",strlen(tc->Text()));
       package->AddString("text",tc->Text());
       a->MessageReceived(package);
/*
Construct the message and pass it on to the RDW_Forward object. Next stop:
The "debug" window!
*/
     };break;
    default:
     {
      BMessage *copy=new BMessage(msg);
      BWindow::MessageReceived(msg);
      PostMessage(copy);
     };break;
   }
  Unlock();
 }
